#!/usr/bin/env perl

# shotlist.pl
#   quick and dirty code by Matthew McCowan

$|++;
use strict;
use warnings;


my ($line
   ,$previous_line_was_blank
   ,$title
   ,$shot
   ,$count
   );


$previous_line_was_blank  = 0;
$count                    = 0;

while(<>) {
    chomp();
    $line  = $_;

    if ($line =~ m/^\s*$/) {
        $previous_line_was_blank  = 1;
        next;
    }

    if ($line =~ m/^Title:/) {
        $title  = $';         # everything after the match
        $title =~ s/^\s*[\_\*]*//;
        $title =~ s/[\_\*]*\s*$//;
        
        print "# $title\n\n\nShotlist\n";
    } elsif ($previous_line_was_blank && is_scene_heading($line)) {
        $count  = 0;
        $line  =~ s/^\.//;
        print "\n\n## $line\n\n\n";
    } else {
        while($line =~ m/\[\[Shot:(.+?)\]\]/ig) {
            $count++;
            $shot  = $&;
            $shot =~ s/^\[\[Shot:\s*//i;
            $shot =~ s/\s*\]\]$//;
            print "${count}. $shot\n";
        }
    }

    $previous_line_was_blank   = 0;
}



sub is_scene_heading {
    my $i  = shift @_ || '';
    
    return 0 if $i =~ m/  $/;             # ends with 2 spaces
    return 1 if $i =~ m/^\.[a-zA-Z0-9]/;  # begins with period
    return 1 if $i =~ m/^(INT|EXT|EST|I\/E|INT\.\/EXT|INT\/EXT|I\/E)\./i;
    return 0;
}
